/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2009 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Sam Lantinga
    slouken@libsdl.org
*/
module org.libsdl.error;

extern (C)
{
	void SDL_SetError(const(char)* fmt, ...);
	char* SDL_GetError();
	void SDL_ClearError();
}

enum SDL_errorcode
{
	SDL_ENOMEM,
	SDL_EFREAD,
	SDL_EFWRITE,
	SDL_EFSEEK,
	SDL_UNSUPPORTED,
	SDL_LASTERROR
}

alias SDL_errorcode.SDL_ENOMEM SDL_ENOMEM;
alias SDL_errorcode.SDL_EFREAD SDL_EFREAD;
alias SDL_errorcode.SDL_EFWRITE SDL_EFWRITE;
alias SDL_errorcode.SDL_EFSEEK SDL_EFSEEK;
alias SDL_errorcode.SDL_UNSUPPORTED SDL_UNSUPPORTED;
alias SDL_errorcode.SDL_LASTERROR SDL_LASTERROR;

extern (C)
{
	void SDL_Error(SDL_errorcode code);
}

void SDL_OutOfMemory()
{
	SDL_Error(SDL_errorcode.SDL_ENOMEM);
}

void SDL_Unsupported()
{
	SDL_Error(SDL_errorcode.SDL_UNSUPPORTED);
}
