/*
    SDL_image:  An example image loading library for use with SDL
    Copyright (C) 1997-2009 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Sam Lantinga
    slouken@libsdl.org
*/
module org.libsdl.image;

import org.libsdl.error;
import org.libsdl.rwops;
import org.libsdl.stdinc;
import org.libsdl.video;
import org.libsdl.versions;

immutable uint SDL_IMAGE_MAJOR_VERSION = 1;
immutable uint SDL_IMAGE_MINOR_VERSION = 2;
immutable uint SDL_IMAGE_PATCHLEVEL    = 10;

void SDL_IMAGE_VERSION(ref SDL_version ver)
{
	ver.major = SDL_IMAGE_MAJOR_VERSION;
	ver.minor = SDL_IMAGE_MINOR_VERSION;
	ver.patch = SDL_IMAGE_PATCHLEVEL;
}

extern (C)
{
	const(SDL_version)* IMG_Linked_Version();
}

enum IMG_InitFlags : uint
{
	IMG_INIT_JPG = 0x00000001,
	IMG_INIT_PNG = 0x00000002,
	IMG_INIT_TIF = 0x00000004
}

extern (C)
{
	int IMG_Init(int flags);
	void IMG_Quit();
	SDL_Surface* IMG_LoadTyped_RW(SDL_RWops* src, int freesrc, char* type);
	SDL_Surface* IMG_Load(const(char)* file);
	SDL_Surface* IMG_Load_RW(SDL_RWops* src, int freesrc);
	int IMG_InvertAlpha(int on);
	int IMG_isICO(SDL_RWops* src);
	int IMG_isCUR(SDL_RWops* src);
	int IMG_isBMP(SDL_RWops* src);
	int IMG_isGIF(SDL_RWops* src);
	int IMG_isJPG(SDL_RWops* src);
	int IMG_isLBM(SDL_RWops* src);
	int IMG_isPCX(SDL_RWops* src);
	int IMG_isPNG(SDL_RWops* src);
	int IMG_isPNM(SDL_RWops* src);
	int IMG_isTIF(SDL_RWops* src);
	int IMG_isXCF(SDL_RWops* src);
	int IMG_isXPM(SDL_RWops* src);
	int IMG_isXV(SDL_RWops* src);
	SDL_Surface* IMG_LoadICO_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadCUR_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadBMP_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadGIF_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadJPG_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadLBM_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadPCX_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadPNG_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadPNM_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadTGA_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadTIF_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadXCF_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadXPM_RW(SDL_RWops* src);
	SDL_Surface* IMG_LoadXV_RW(SDL_RWops* src);
	SDL_Surface* IMG_ReadXPMFromArray(char** xpm);
}

alias SDL_SetError IMG_SetError;
alias SDL_GetError IMG_GetError;

